---
title: XRInputSourceArray.length
slug: Web/API/XRInputSourceArray/length
tags:
  - API
  - AR
  - Input Sources
  - Inputs
  - Mixed
  - Property
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourceArray
  - augmented
  - controllers
  - count
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p>The read-only <code><strong>length</strong></code> property returns an integer value indicating the number of items in the input source list represented by the {{domxref("XRInputSourceArray")}} object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>inputSourceCount</em> = <em>xrInputSourceArray</em>.length;</pre>

<h3 id="Value">Value</h3>

<p>An integer value indicating the number of {{domxref("XRInputSource")}} objects representing WebXR input sources are includled in the array.</p>

<h2 id="Examples">Examples</h2>

<p>In this example, a game that requires at least one input source uses <code>length</code> to check this before proceeding to allow the user to play the game.</p>

<pre class="brush: js notranslate">let sources = xrSession.inputSources;

if (sources.length === 0) {
  showAlertDialog("You need to have at least one controller to play Super Duper Shark Jump Fest 9000.",
                  [
                    { label: "Shop Now", url: "https://www.amazon.com/s?k=vr+controllers" },
                    { label: "Quit" handler: quitGame }
                  ]);
}</pre>

<p>Here, if <code>length</code> is 0, a hypothetical <code>showAlertDialog()</code> function is called with a prompt string explaining the need for a controller, and an array of objects, each describing a button and what should happen when it's clicked. The first takes the user to an Amazon.com search for VR controllers, and the second calls a <code>quitGame()</code> function to start shutting the game program down.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrinputsourcearray-length','XRInputSourceArray.length')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRInputSourceArray.length")}}</p>
